//+------------------------------------------------------------------+
//|                                                    Clock_MTF.mq4 |
//+------------------------------------------------------------------+
#property copyright                                "Copyright  2009"
#property link                                            "Clock_MTF"
#property indicator_separate_window
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
extern string  myFont   = "Arial Bold" ;
extern int     FontSz   = 14;

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool     show.M1     = true ;
bool     show.M5     = true ;
bool     show.M15    = true ;
bool     show.M30    = true ;
bool     show.H1     = true ;
bool     show.H4     = true ;
bool     show.D1     = true ;
int      TimeFrame   = 0;
string   prefix      = "Clock MTF.";
int      Win;

color    ClksColor   = Green;
color    SameTFColor = Red;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double s1[];

int init()
   {
   IndicatorShortName(prefix); 

   switch(TimeFrame)
      {
      case 1      :  string   TimeFrameStr = "M1" ;   break;
      case 5      :           TimeFrameStr = "M5" ;   break;
      case 15     :           TimeFrameStr = "M15";   break;
      case 30     :           TimeFrameStr = "M30";   break;
      case 60     :           TimeFrameStr = "H1" ;   break;
      case 240    :           TimeFrameStr = "H4" ;   break;
      case 1440   :           TimeFrameStr = "D1" ;   break;
      case 10080  :           TimeFrameStr = "W1" ;   break;
      case 43200  :           TimeFrameStr = "MN1";   break;
      default     :           TimeFrameStr = "CurrTF";
      }
   return(0);  
   }
//+------------------------------------------------------------------+
//|  Custom indicator deinitialization function                      |
//+------------------------------------------------------------------+
int deinit()
   {
   return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   Win = WindowFind(prefix);
   if (Win == -1) Win = 0;
  
   if (TimeFrame==0) TimeFrame=Period();
   int yPos = 2, xPos = 70;
   int xSpacer = 120;

   for(double i = 1; i <= 10; i++) 
   {
      switch(i)
      {
         case 1: if(show.M1)  CreateLabel(prefix + "clock" + i, PERIOD_M1,  "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 2: if(show.M5)  CreateLabel(prefix + "clock" + i, PERIOD_M5,  "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 3: if(show.M15) CreateLabel(prefix + "clock" + i, PERIOD_M15, "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 4: if(show.M30) CreateLabel(prefix + "clock" + i, PERIOD_M30, "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 5: if(show.H1)  CreateLabel(prefix + "clock" + i, PERIOD_H1,  "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 6: if(show.H4)  CreateLabel(prefix + "clock" + i, PERIOD_H4,  "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
         case 7: if(show.D1)  CreateLabel(prefix + "clock" + i, PERIOD_D1,  "", FontSz, myFont, ClksColor, 0, xPos, yPos); break;
      }
      xPos = xPos+xSpacer;     
   }
   return(0);
  }
//+------------------------------------------------------------------+
void CreateLabel(string LblName, int TFrame, string text, double FontSz, string FontName, color FontColor, int Corner, int xPos, int yPos)
{
	double i;
   int m,s,k,h; 
   string LabelTxt; 
   color FColor;
   LabelTxt = text;
   if (TFrame > -1)
   {
      m=iTime(NULL,TFrame,0)+TFrame*60 - CurTime();
      i=m/60.0;
      s=m%60;
      m=(m-m%60)/60;
      h=m/60;
      LabelTxt =  "[" + TF2Str(TFrame) + "] "+m+"m:"+s; 
   }
   FColor = FontColor;
   if(Period()==TFrame) FColor = SameTFColor;
   if(ObjectFind(LblName) != 0) ObjectCreate(LblName, OBJ_LABEL, Win, 0, 0);
   ObjectSetText(LblName, LabelTxt, FontSz, FontName, FColor);
   ObjectSet(LblName, OBJPROP_CORNER, Corner);
   ObjectSet(LblName, OBJPROP_XDISTANCE, xPos);
   ObjectSet(LblName, OBJPROP_YDISTANCE, yPos); 
}
//+------------------------------------------------------------------+
string TF2Str(int period) 
{
  switch (period) 
  {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("D1");
    case PERIOD_W1:  return("W1");
    case PERIOD_MN1: return("MN");
  }
  return (Period());
}
//+------------------------------------------------------------------+